import java.io.*;
import java.net.*;

public class ServerCore {
  public static int MAXCLIENTS = 2;
  //ayudante ingresa su horario por consola
  private static int state = 0; //0 significa que esperamos respuestas de alumnos, 1 significa que cerramos la espera
  public static int contadorAlumnos = 0;
  public static int contadorRespuestas = 0;
  public static String ayudaClase;
  private static ServerThread[] clientes;
  private static int indexCliente = 0;

  public static int[] lunes = {0,0,0,0,0,0,0};
  public  static int[] martes = {0,0,0,0,0,0,0};
  public  static int[] miercoles = {0,0,0,0,0,0,0};
  public  static int[] jueves = {0,0,0,0,0,0,0};
  public  static int[] viernes = {0,0,0,0,0,0,0};

  public static int[] lunesAyudante = {0,0,0,0,0,0,0};
  public  static int[] martesAyudante = {0,0,0,0,0,0,0};
  public  static int[] miercolesAyudante = {0,0,0,0,0,0,0};
  public  static int[] juevesAyudante = {0,0,0,0,0,0,0};
  public  static int[] viernesAyudante = {0,0,0,0,0,0,0};

  private static int fijarDia1 = -1;
  private static int fijarBloque1 = -1;
  private static int fijarDia2 = -1;
  private static int fijarBloque2 = -1;

  public static void main(String[] args) throws IOException {
    int portClients = 12345;
    if (args.length > 0 && args.length<3) {
        try {
            portClients = Integer.parseInt(args[0]);
            MAXCLIENTS = Integer.parseInt(args[1]);
        } catch (NumberFormatException e) {
            System.err.println("Error, Uso: ./ServerCore <puerto para conectar clientes> <Cantidad de alumnos>");
            System.exit(1);
        }
    }else{
      System.err.println("Error, Uso: ./ServerCore <puerto para conectar clientes> <Cantidad de alumnos>");
      System.exit(1);
    }
    
    clientes = new ServerThread[MAXCLIENTS];
    System.out.println("Bienvenido! este programa le ayudara a coordinar el horario para su ayudantia");

    AskSchedule();
    PrintSchedule(lunes, martes,miercoles, jueves,viernes,0);

    ServerSocket sClients = new ServerSocket(portClients);

    System.out.println("Server Started");
    try {
      int cont = 0;
      while(state == 0) {
        if (contadorAlumnos != MAXCLIENTS){
          // Blocks until a connection from a client occurs:
          Socket socket = sClients.accept();
          contadorAlumnos+=1;
          try {
            //start the thread to attend the client
            ServerThread s1 = new ServerThread(socket);
            clientes[indexCliente] = s1;
            indexCliente++;
          } catch(IOException e) {
            // If it fails, close the socket,
            socket.close();
          }
        }else{
          System.out.print("");
          if (contadorRespuestas==MAXCLIENTS){
            System.out.println("Se recibio respuesta del ultimo alumno.");
            
            SearchBestChoice(lunes, martes, miercoles, jueves, viernes,0);
            
            PrintFixedSchedule(fijarDia1,fijarBloque1);
            TellClients(clientes,1,0);

            SecondChance();

            System.out.println();
            System.out.println();

            PrintScheduleClientsRequest(clientes,fijarDia1,fijarBloque1,fijarDia2,fijarBloque2);

            PrintFixedSchedule(fijarDia1,fijarBloque1);
            PrintFixedSchedule(fijarDia2,fijarBloque2);

            System.out.println();
            System.out.println();

            System.out.println("Gracias por su preferencia, Nos Vemos!");
            state = 1;
          }
        }
      }
      while(state == 1){
        System.exit(0);
      };
    } finally {
      sClients.close();
    }
  }

  public static int[] StringToArray(String stringHorario){
    char[] chars;
    int[] day = {0,0,0,0,0,0,0};
    if (stringHorario.length()>=7){
      chars = stringHorario.toCharArray();
      for (int i=0;i<7 ;i++ ) {
        if (chars[i]!='0'){
          day[i] = 1;
        }else{
          day[i] = 0;
        }
      }
    }else{
      chars = stringHorario.toCharArray();
      for (int j=0;j<7 ;j++) {
        if(j<stringHorario.length()){
          if (chars[j]!='0'){
            day[j] = 1;
          }else{
            day[j] = 0;
          }
        }else{
          day[j] = 0;
        }
      }
    }
    return day;
  }

  public static void CountDay(int[] day, int[] addClient){
    for (int i = 0; i<day.length; i++) {
      day[i] += addClient[i];
    }
  }

  //retorna el indice del primer bloque libre del dia, si no hay retorna -1
  private static int FirstFreeOfTheDay(int[] day){
    for (int i=0;i<7;i++) {
      if(day[i]==0){
        return i;
      }
    }
    return -1;
  }

  private static int CollisionFreeCount(int[] day){
    int libres = 0;
    for (int i = 0;i<7 ; i++) {
      if (day[i]==0){
        libres++;
      }
    }
    return libres;
  }

  private static int[] CollisionFreeCheckWeek(int[] lu,int[] ma,int[] mi,int[] ju,int[] vi){
    int[] libres = {0,0,0,0,0};
    libres[0] = CollisionFreeCount(lu);
    libres[1] = CollisionFreeCount(ma);
    libres[2] = CollisionFreeCount(mi);
    libres[3] = CollisionFreeCount(ju);
    libres[4] = CollisionFreeCount(vi);
    return libres;
  }
  private static int CollisionNumberCount(int[] day,int colls){
    int libres = 0;
    for (int i = 0;i<7 ; i++) {
      if (day[i]==colls){
        libres++;
      }
    }
    return libres;
  }

  private static int[] CollisionNumberCheckWeek(int[] lu,int[] ma,int[] mi,int[] ju,int[] vi, int colls){
    int[] conIgualTope = {0,0,0,0,0};
    conIgualTope[0] = CollisionNumberCount(lu,colls);
    conIgualTope[1] = CollisionNumberCount(ma,colls);
    conIgualTope[2] = CollisionNumberCount(mi,colls);
    conIgualTope[3] = CollisionNumberCount(ju,colls);
    conIgualTope[4] = CollisionNumberCount(vi,colls);
    return conIgualTope;
  }

  private static int[] MinCollisionGlobal(int umbral, int[] lu, int[] ma,int[] mi, int[]ju, int[] vi, int interferirAyudante){
    int topesMin = 1000;
    int bloqueMin = -1;
    int dayMin = -1;
    int[] diaBloqueTopes = {-1,-1,-1};
    for(int i=0;i<7;i++){
      if(lunesAyudante[i]==0 || interferirAyudante==1){
        if(lu[i]<topesMin){
          if(lu[i]>umbral){
            topesMin = lunes[i];
            bloqueMin = i;
            dayMin = 0;
          }
        }
      }
      if(martesAyudante[i]==0 || interferirAyudante==1){
        if(ma[i]<topesMin){
          if(ma[i]>umbral){
            topesMin = martes[i];
            bloqueMin = i;
            dayMin = 1;
          }
        }
      }
      if(miercolesAyudante[i]==0 || interferirAyudante==1){
        if(mi[i]<topesMin){
          if(mi[i]>umbral){
            topesMin = miercoles[i];
            bloqueMin = i;
            dayMin = 2;
          }
        }
      }
      if(juevesAyudante[i]==0 || interferirAyudante==1){
        if(ju[i]<topesMin){
          if(ju[i]>umbral){
            topesMin = jueves[i];
            bloqueMin = i;
            dayMin = 3;
          }
        }
      }
      if(viernesAyudante[i]==0 || interferirAyudante==1){
        if(vi[i]<topesMin){
          if(vi[i]>umbral){
            topesMin = viernes[i];
            bloqueMin = i;
            dayMin = 4;
          }
        }
      }
    }
    diaBloqueTopes[0] = dayMin;
    diaBloqueTopes[1] = bloqueMin;
    diaBloqueTopes[2] = topesMin;
    //System.out.println("dia= "+dayMin);
    //System.out.println("block= "+ bloqueMin);
    return diaBloqueTopes;
  }

  public static void SearchBestChoice(int[] lu,int[] ma,int[] mi,int[] ju,int[] vi, int fijar2){
    int[] libres = CollisionFreeCheckWeek(lu, ma, mi, ju, vi);
    int nLibres = 0;
    for (int j = 0;j<5 ;j++ ) {
      nLibres += libres[j];
    }
     
    if(nLibres==0){
      //No hay bloques sin tope :c
      System.out.println("No se encontraron bloques sin tope!");
      System.out.println();
      PrintSchedule(lu,ma,mi,ju,vi,0);
      int ignorarAyudante = 0;
      int[] diaBloqueTope = MinCollisionGlobal(0,lu,ma,mi,ju,vi,ignorarAyudante);
      if(diaBloqueTope[0]<0 || diaBloqueTope[1]<0){
        System.out.println("Imposible Fijar horario sin interferir con horario del ayudante");
        PrintSchedule(lunesAyudante,martesAyudante,miercolesAyudante,juevesAyudante,viernesAyudante,0);
        System.out.println("Desea interferir con el horario del ayudante? si/no");
        int goodAns = 0;
        while(goodAns==0){
          String intervenir = System.console().readLine();
          char[] charI = intervenir.toCharArray();
          if(charI[0]=='s'){
            goodAns = 1;
            ignorarAyudante = 1;
            diaBloqueTope = MinCollisionGlobal(0,lu,ma,mi,ju,vi,ignorarAyudante);
          }else if (charI[0]=='n'){
            System.out.println("Hasta pronto!");
            System.exit(1);
          }else{
            System.out.println("Si desea ignorar los topes con el horario del ayudante escriba: si");
            System.out.println("En caso contrario escriba: no");
          }
        }
      }else{
        System.out.println("Horario con menor cantidad de topes: ");
      }
      int[] conIgualTope = CollisionNumberCheckWeek(lu,ma,mi,ju,vi,diaBloqueTope[2]);
      int nIgualTope = 0;
      for (int n=0;n<conIgualTope.length ;n++ ) {
        nIgualTope+=conIgualTope[n];
      }

      if(nIgualTope==1){
        if (fijar2==0){
          fijarDia1 = diaBloqueTope[0];
          fijarBloque1 = diaBloqueTope[1];
        }else{
          fijarDia2 = diaBloqueTope[0];
          fijarBloque2 = diaBloqueTope[1];
        }
      }else if(nIgualTope>1){
        //Hay mas de un bloque con el minimo de topes encontrado
        System.out.println("Se econtro mas de un horario con el minimo tope disponible!");
        System.out.println();
        PrintSchedule(lu,ma,mi,ju,vi,0);
        int isReadyTope = 0;
        while(isReadyTope==0){
          System.out.println("Para fijar un horario escriba las iniciales del dia y el bloque");
          System.out.println("Ejemplo; para fijar Lunes 1-2 debe ingresar: lu1 ");
          String fijarStringTope = System.console().readLine();
          //revisar si el escogido esta libre
          if(fijarStringTope.length()>0){
            isReadyTope = FixSchedule(lu,ma,mi,ju,vi,fijarStringTope,fijar2,diaBloqueTope[2],ignorarAyudante);
          }
        }
      }
    } else if(nLibres==1){
      //Hay 1 bloque sin tope, se escoge ese y el siguiente con menor tope
      System.out.println("Se econtro solo un horario sin topes!");
      System.out.println();
      PrintSchedule(lu,ma,mi,ju,vi,0);
      int[] temp= {};
      int dia = -1;
      for (int k=0;k<5 ;k++ ) {
        if (libres[k]==1){
          if (k==0){
            temp = lu;
            dia = k;
          }
          if (k==1){
            temp = ma;
            dia = k;
          }
          if (k==2){
            temp = mi;
            dia = k;
          }
          if (k==3){
            temp = ju;
            dia = k;
          }
          if (k==4){
            temp = vi;
            dia = k;
          }
        }
      }
      int unicoBloque =FirstFreeOfTheDay(temp);
      if(fijar2==0){
        fijarDia1 =  dia;
        fijarBloque1 = unicoBloque;
      }else{
        fijarDia2 =  dia;
        fijarBloque2 = unicoBloque;
      }

    } else if (nLibres>1){
      //Hay mas de un bloque sin tope c:
      System.out.println("Se econtro mas de un horario disponible!");
      System.out.println();
      PrintSchedule(lu,ma,mi,ju,vi,0);
      int isReady = 0;
      while(isReady==0){
        System.out.println("Para fijar un horario escriba las iniciales del dia y el bloque");
        System.out.println("Ejemplo; para fijar Lunes 1-2 debe ingresar: lu1 ");
        String fijarString = System.console().readLine();
        //revisar si el escogido esta libre
        if(fijarString.length()>0){
          isReady = FixSchedule(lu,ma,mi,ju,vi,fijarString,fijar2,0,0);
        }
      }
    }
  }

  private static int FixSchedule(int[] lu, int[] ma, int[] mi, int[] ju, int[] vi,String fijarStr,int fijar2, int minTope, int ignorarAyudante){
    char[] charF = fijarStr.toCharArray();
    char[] dayChars =new char[2];
    int index = Character.getNumericValue(charF[charF.length-1])-1;
    if (index>=7){
      System.out.println("Este bloque no existe!");
      return 0;
    }
    switch(charF[0]){
      case 'l':{
        //lunes
        if (lu[index]==minTope && (lunesAyudante[index]==0 || ignorarAyudante==1) ){
          if(fijar2==0){
            fijarDia1 = 0;
            fijarBloque1 = index;
          }else{
            fijarDia2 = 0;
            fijarBloque2 = index;
          }
          return 1;
        }
        break;
      }
      case 'm':{
        if(charF[1]=='a'){
          //martes
          if (ma[index]==minTope && (martesAyudante[index]==0 || ignorarAyudante==1)){
            if(fijar2==0){
              fijarDia1 = 1;
              fijarBloque1 = index;
            }else{
              fijarDia2 = 1;
              fijarBloque2 = index;
            }
            return 1;
          }
        }else if(charF[1]=='i'){
          //miercoles
          if (mi[index]==minTope && (miercolesAyudante[index]==0 || ignorarAyudante==1)){
            if(fijar2==0){
              fijarDia1 = 2;
              fijarBloque1 = index;
            }else{
              fijarDia2 = 2;
              fijarBloque2 = index;
            }
            return 1;
          }
        }
        break;
      }
      case 'j':{
        //jueves
        if (ju[index]==minTope && (juevesAyudante[index]==0 || ignorarAyudante==1)){
          if(fijar2==0){
            fijarDia1 = 3;
            fijarBloque1 = index;
          }else{
            fijarDia2 = 3;
            fijarBloque2 = index;
          }
          return 1;
        }
        break;
      }
      case 'v':{
        //viernes
        if (vi[index]==minTope && (viernesAyudante[index]==0 || ignorarAyudante==1)){
          if(fijar2==0){
            fijarDia1 = 4;
            fijarBloque1 = index;
          }else{
            fijarDia2 = 4;
            fijarBloque2 = index;
          }
          return 1;
        }
        break;
      }
    }
    System.out.println("Este bloque tiene muchos topes! (o topa con el ayudante)");
    return 0;
  }

  private static void PrintFixedSchedule(int dia, int bloque){
    if(dia<0 || bloque<0){
      return;
    }
    String diaS = "dia";
    String bloqueS = "bloque";
    switch(dia){
      case 0:{
        diaS = "Lunes";
        break;
      }
      case 1:{
        diaS = "Martes";
        break;
      }
      case 2:{
        diaS = "Miercoles";
        break;
      }
      case 3:{
        diaS = "Jueves";
        break;
      }
      case 4:{
        diaS = "Viernes";
        break;
      }
    }
    int bloque1Real = 1+2*bloque;
    int bloque2Real = bloque1Real+1;
    bloqueS = bloque1Real+"-"+bloque2Real;

    System.out.println("Se ha fijado el horario: "+diaS+" "+bloqueS);
  }

  public static void PrintScheduleClientsRequest(ServerThread[] clientList,int fd1, int fb1, int fd2,int fb2){
    for (int i=0;i<clientList.length;i++) {
      clientList[i].WriteSchedule(fd1,fb1,fd2,fb2);
    }
  }

  public static void PrintSchedule(int[] lu,int[] ma,int[] mi, int[] ju, int[] vi, int ignorarAyudante){
    int bloqueP1 = 1;
    int bloqueP2 = 2;
    System.out.println("Bloque |lu| ma| mi| ju| vi|");
    for (int j=0;j<7 ;j++) {
      if(bloqueP2<9){
        System.out.print( bloqueP1 +" - "+bloqueP2+"  |");
      }else{
        if (bloqueP2==10){
          System.out.print( bloqueP1 +" - "+bloqueP2+" |");
        }else{
          System.out.print( bloqueP1 +" - "+bloqueP2+"|");
        }
      }
      char blocked='x';
      if(lunesAyudante[j]==0 || ignorarAyudante==1){
        System.out.print(" "+lu[j]);
      }else{
        System.out.print(" "+blocked);
      }
      System.out.print("| ");
      if(martesAyudante[j]==0 || ignorarAyudante==1){
        System.out.print(" "+ma[j]);
        }else{
        System.out.print(" "+blocked);
      }
      System.out.print("| ");
      if(miercolesAyudante[j]==0 || ignorarAyudante==1){
        System.out.print(" "+mi[j]);
        }else{
        System.out.print(" "+blocked);
      }
      System.out.print("| ");
      if(juevesAyudante[j]==0 || ignorarAyudante==1){
        System.out.print(" "+ju[j]);
        }else{
        System.out.print(" "+blocked);
      }
      System.out.print("| ");
      if(viernesAyudante[j]==0 || ignorarAyudante==1){
        System.out.print(" "+vi[j]);
        }else{
        System.out.print(" "+blocked);
      }
      System.out.print("|");
      System.out.println();
      if(bloqueP2==6){
        System.out.println("----------Almuerzo---------");
      }
      bloqueP1 += 2;
      bloqueP2 = bloqueP1+1;
    }
    System.out.println();
  }

  private static void TellClients(ServerThread[] stArray, int printBool, int fijar2){
    for (int i=0;i<stArray.length ; i++) {
      if(fijar2==0){
        stArray[i].CheckIfCanAssit(fijarDia1,fijarBloque1,printBool);
      }else{
        stArray[i].CheckIfCanAssit(fijarDia2,fijarBloque2,printBool);
      }
    }
  }
  private static ServerThread[] CollisionClients(int fd, int fb){
    int collisionClients = 0;
    int troubleIndex = 0;
    for (int i=0;i<MAXCLIENTS ; i++) {
      int canAssist = clientes[i].CheckIfCanAssit(fd,fb,0);
      if(canAssist==0){
        collisionClients++;
      }
    }
    ServerThread[] troubledClients = new ServerThread[collisionClients];
    for (int i = 0;i<MAXCLIENTS ;i++ ) {
      int canAssist = clientes[i].CheckIfCanAssit(fd,fb,0);
      if(canAssist==0){
        troubledClients[troubleIndex] = clientes[i];
        troubleIndex++;
      }
    }
    return troubledClients;
  }

  private static void SecondChance(){
    System.out.println();
    System.out.println("Buscamos un segundo horario . . .");
    ServerThread[] clientesTope =  CollisionClients(fijarDia1,fijarBloque1);
    int[] lunes2 = new int[7];
    int[] martes2 = new int[7];
    int[] miercoles2 = new int[7];
    int[] jueves2 = new int[7];
    int[] viernes2 = new int[7];
    CopyArrayData(lunesAyudante,lunes2);
    CopyArrayData(martesAyudante,martes2);
    CopyArrayData(miercolesAyudante,miercoles2);
    CopyArrayData(juevesAyudante,jueves2);
    CopyArrayData(viernesAyudante,viernes2);
    for (int i=0;i<clientesTope.length ; i++) {
      clientesTope[i].AddSchedule(lunes2,martes2,miercoles2,jueves2,viernes2);
    }
    SearchBestChoice(lunes2,martes2,miercoles2,jueves2,viernes2,1);
    PrintFixedSchedule(fijarDia2,fijarBloque2);
    TellClients(clientesTope,1,1);
  }

  private static void CopyArrayData(int[] fromMe, int[] toYou){
    if(fromMe.length!=toYou.length){
      return;
    }
    for (int i=0; i<toYou.length; i++) {
      toYou[i] = fromMe[i];
    }
  }

  public static void AskSchedule(){
    System.out.println("Nombre de la Ayudantia: ");
    ayudaClase = System.console().readLine();
    System.out.println("Ingrese una cadena de 1s y 0s indicando con 1 los bloques ocupados");
    System.out.println("por ejemplo, si ingresa: ");
    System.out.println("1 2 3 4 5 6 7");
    System.out.println("1 1 1 0 0 0 0");
    System.out.println("Corresponde a un dia en que tiene ocupado bloques del 1 al 6");

    System.out.println("Lunes: ");
    String lunesStr = System.console().readLine();
    lunes = StringToArray(lunesStr);
    lunesAyudante = StringToArray(lunesStr);
    System.out.println("Martes: ");
    String martesStr = System.console().readLine();
    martes = StringToArray(martesStr);
    martesAyudante = StringToArray(martesStr);
    System.out.println("Miercoles: ");
    String miercolesStr = System.console().readLine();
    miercoles = StringToArray(miercolesStr);
    miercolesAyudante = StringToArray(miercolesStr);    
    System.out.println("Jueves: ");
    String juevesStr = System.console().readLine();
    jueves = StringToArray(juevesStr);
    juevesAyudante = StringToArray(juevesStr);
    System.out.println("Viernes: ");
    String viernesStr = System.console().readLine();
    viernes = StringToArray(viernesStr);
    viernesAyudante = StringToArray(viernesStr);
    System.out.println("Horario ayudante ingresado correctamente.");

   }

}
